<?php

/*
Plugin Name: Evoca Voice Comments Recorder
Description:This plugin enables you to invite visitors to your WordPress blog or website to record comments, opinions, suggestions, language practice sessions, interviews, stories, poems, auditions, and any other voice or audio content using a computer mic. An Evoca account is required, see <a href="http://www.evoca.com">http://www.evoca.com</a>
Version: 1.0.2
Plugin URI: http://www.evoca.com/myaccount/comment-recorder-wordpress.jsp
Author: Adam Tootle
*/


add_action('admin_menu', 'evoca_audio_comments_add_admin_page');
register_activation_hook( __FILE__, 'evoca_aduio_comments_add_options' );



function evoca_aduio_comments_add_options(){
	if(get_option('evoca_audio_comments_enabled') == ''){
		add_option('evoca_audio_comments_enabled', 'no');
	}
}

function evoca_audio_comments_add_admin_page() {
  add_options_page('Evoca Voice Comments Recorder Settings', 'Evoca Voice Comments Recorder', 'edit_plugins', 'evoca_audio_comments', 'evoca_audio_comments_options');
}

function evoca_audio_comments_options(){

$output = '';
	
  	
  	$output .= "<h2>Evoca Voice Comments Recorder</h2>";
  	$output .= "<div style=\"margin-bottom:15px\">
  				To use the Evoca Voice Comments Recorder, you need to have an evoca.com account. To signup, please visit <a href=\"http://www.evoca.com\" target=\"_blank\">www.evoca.com</a>
  				</div>";
  	$output .= "<div>";
  	
  	if(isset($_POST['evoca_username'])){
  	
  		update_option('evoca_username', $_POST['evoca_username']);
  		
  		if($_POST['evoca_password'] != ''){
  			update_option('evoca_password', sha1($_POST['evoca_password']));
  		}else{
  			update_option('evoca_password', '');
  		}
  		
  		if($_POST['evoca_username'] == '' OR $_POST['evoca_password'] == ''){
  			update_option('evoca_user_id', '');
  		}
  		
  		$style = "background-color: lightYellow;
					border-color: #E6DB55;
					border-bottom-left-radius: 3px 3px;
					border-bottom-right-radius: 3px 3px;
					border-style: solid;
					border-width: 1px;
					border-top-left-radius: 3px 3px;
					border-top-right-radius: 3px 3px;
					margin: 15px 0;
					padding: 5px 10px;";
					
  		//$output .= "<div style=\"$style\">Settings Updated</div>";
  		
  		if(audio_comments_check_username_and_password()){
  			$style = "background-color: #00cc00;
	    		border-color: #E6DB55;
	    		border-bottom-left-radius: 3px 3px;
	    		border-bottom-right-radius: 3px 3px;
	    		border-style: solid;
	    		border-width: 1px;
	    		border-top-left-radius: 3px 3px;
	    		border-top-right-radius: 3px 3px;
	    		padding: 5px 10px;";
	    		
  			$output .= "<div style=\"$style\">Account Validated!</div>";
  			
  		}elseif(get_option('evoca_username') == '' AND get_option('evoca_password') == ''){
  		
  			$style = "background-color: #ff3333;
		    		border-color: #E6DB55;
		    		border-bottom-left-radius: 3px 3px;
		    		border-bottom-right-radius: 3px 3px;
		    		border-style: solid;
		    		border-width: 1px;
		    		border-top-left-radius: 3px 3px;
		    		border-top-right-radius: 3px 3px;
		    		padding: 5px 10px;";
		    		
  			$output .= "<div style=\"$style\">Please enter your Evoca username and password.</div>";

  		}else{
  		
  			$style = "background-color: #ff3333;
	    		border-color: #E6DB55;
	    		border-bottom-left-radius: 3px 3px;
	    		border-bottom-right-radius: 3px 3px;
	    		border-style: solid;
	    		border-width: 1px;
	    		border-top-left-radius: 3px 3px;
	    		border-top-right-radius: 3px 3px;
	    		padding: 5px 10px;";
	    		
  			$output .= "<div style=\"$style\">Username and/or Password Incorrect.</div>";
  		
  		}
  	}
  	
  	$evoca_username = get_option('evoca_username');
  	$evoca_password = get_option('evoca_password');
  	$evoca_user_id = get_option('evoca_user_id');
  	
  	if(!isset($_POST['evoca_username'])){
  		
  		if($evoca_username == '' AND $evoca_password == ''){
  		    $style = "background-color: #ff3333;
		    		border-color: #E6DB55;
		    		border-bottom-left-radius: 3px 3px;
		    		border-bottom-right-radius: 3px 3px;
		    		border-style: solid;
		    		border-width: 1px;
		    		border-top-left-radius: 3px 3px;
		    		border-top-right-radius: 3px 3px;
		    		padding: 5px 10px;";
		    		
  		$output .= "<div style=\"$style\">Please enter your Evoca username and password.</div>";
  		}
  		if(($evoca_username != '' OR $evoca_password != '') AND $evoca_user_id == ''){
  		    $style = "background-color: #ff3333;
		    		border-color: #E6DB55;
		    		border-bottom-left-radius: 3px 3px;
		    		border-bottom-right-radius: 3px 3px;
		    		border-style: solid;
		    		border-width: 1px;
		    		border-top-left-radius: 3px 3px;
		    		border-top-right-radius: 3px 3px;
		    		padding: 5px 10px;";
		    		
  			$output .= "<div style=\"$style\">Username and/or Password Incorrect.</div>";
  		}
  		if($evoca_user_id != ''){
  		
  			$style = "background-color: #00cc00;
		    		border-color: #E6DB55;
		    		border-bottom-left-radius: 3px 3px;
		    		border-bottom-right-radius: 3px 3px;
		    		border-style: solid;
		    		border-width: 1px;
		    		border-top-left-radius: 3px 3px;
		    		border-top-right-radius: 3px 3px;
		    		padding: 5px 10px;";
		    		
  			$output .= "<div style=\"$style\">Account Validated!</div>";
  		
  		}
  	}
  	
  	
  	$output .= "<form method=\"post\">";
  	$output .= "<table class=\"widefat\" style=\"width:200px; margin-top:15px\">
  	    			<thead>
  	    			    <tr>
  	    			    	<th colspan=\"2\">Account Information</th>
  	    			    </tr>
  	    			</thead>";
  	$output .= "<tr>
  	    			<td>Username</td>
  	    			<td><input name=\"evoca_username\" value=\"$evoca_username\"></td>
  	    		  </tr>
  	    		  <tr>
  	    		  	<td>Password</td>
  	    		  	<td><input name=\"evoca_password\" type=\"password\"></td>
  	    		  </tr>
  	    		  <tr>
  	    		  	<td><input type=\"submit\" style=\"padding:5px 10px; margin:10px 10px; border:thin solid gray\"></td>
					<td></td>
  	    		  </tr>
					<tfoot>
							<th>&nbsp;</th>
							<th></th>
					</tfoot>";
  	$output .= "</form>";
  	$output .= "</table>";
  	
  	$output .= "</div>";
  	echo $output;
	

?>
	<?php
		if(isset($_POST['comments_options']) && $_POST['comments_options'] == 'submitted'){
			if(isset($_POST['comments_enabled'])){
				update_option('evoca_audio_comments_enabled', 'yes');
			}else{
				update_option('evoca_audio_comments_enabled', 'no');
			}
		}
		//echo get_option('evoca_audio_comments_enabled');
	?>
	<h2>Voice Comments</h2>
	<p>
		Enabling voice comments will allow you to use this feature on each individual post/page. You can choose to enable/disable voice comments from the edit screen of each post. You may also choose to use only voice comments for a particular post from this screen (voice comments must be enabled for the post for voice-only comments to work). These will show as a normal comment would for moderation.
	</p>
	<?php if(isset($_POST['comments_options']) && $_POST['comments_options'] == 'submitted'){ ?>
		<div id="message" class="updated below-h2" style="margin-left: 0;"><p>Options Updated</p></div>
	<?php } ?>
	
	<form method="post">
		<input type="hidden" name="comments_options" value="submitted">
		<table class="widefat" style="width: 244px; margin-top: 20px;">
			<thead>
				<th>Option</th>
				<th>Value</th>
			</thead>
			
			<tr>
				<td>Voice Comments Enabled</td>
				<td>
					<?php if(get_option('evoca_audio_comments_enabled') == 'yes'): ?>
	    		  		<input type="checkbox" name="comments_enabled" checked="checked" value="yes"> Yes
					<?php else: ?>
						<input type="checkbox" name="comments_enabled" value="yes"> Yes
					<?php endif; ?>
				</td>
			</tr>
			
			<tr>
				<td><input type="submit" style="padding:5px 10px; margin:10px 10px; border:thin solid gray"></td>
				<td></td>
    		</tr>
			
			<tfoot>
				<th>&nbsp;</th>
				<th></th>
			</tfoot>
		</table>
	</form>
	
	<h2>Quick Actions</h2>
	
	<?php 
	if(isset($_GET['enable_all_posts']) && $_GET['enable_all_posts'] == 'true'){
		global $wpdb;
		$posts = $wpdb->get_results("SELECT * FROM $wpdb->posts WHERE `post_type` = 'post'");
		foreach($posts as $post){
			update_post_meta($post->ID, 'enable_audio_comments', 'yes');
		}
	}
	if(isset($_GET['disable_all_posts']) && $_GET['disable_all_posts'] == 'true'){
		global $wpdb;
		$posts = $wpdb->get_results("SELECT * FROM $wpdb->posts WHERE `post_type` = 'post'");
		foreach($posts as $post){
			delete_post_meta($post->ID, 'enable_audio_comments');
		}
		$comments = $wpdb->get_results("SELECT * FROM $wpdb->comments");
		foreach($comments as $comment){
			if(strpos($comment->comment_content, 'audio_comment') && $comment->comment_approved != 'trash'){
				 wp_set_comment_status($comment->comment_ID, 'hold');
			}
		}
	}
	if(isset($_GET['enable_all_pages']) && $_GET['enable_all_pages'] == 'true'){
		global $wpdb;
		$posts = $wpdb->get_results("SELECT * FROM $wpdb->posts WHERE `post_type` = 'page'");
		foreach($posts as $post){
			update_post_meta($post->ID, 'enable_audio_comments', 'yes');
		}
	}
	if(isset($_GET['disable_all_pages']) && $_GET['disable_all_pages'] == 'true'){
		global $wpdb;
		$posts = $wpdb->get_results("SELECT * FROM $wpdb->posts WHERE `post_type` = 'page'");
		foreach($posts as $post){
			delete_post_meta($post->ID, 'enable_audio_comments');
		}
		$comments = $wpdb->get_results("SELECT * FROM $wpdb->comments");
		foreach($comments as $comment){
			if(strpos($comment->comment_content, 'audio_comment')  && $comment->comment_approved != 'trash'){
				 wp_set_comment_status($comment->comment_ID, 'hold');
			}
		}
	}
	
	
	if(isset($_GET['enable_audio_only_all_posts']) && $_GET['enable_audio_only_all_posts'] == 'true'){
		global $wpdb;
		$posts = $wpdb->get_results("SELECT * FROM $wpdb->posts WHERE `post_type` = 'post'");
		foreach($posts as $post){
			update_post_meta($post->ID, 'enable_audio_comments', 'yes');
			update_post_meta($post->ID, 'enable_audio_only_comments', 'yes');
		}
	}
	if(isset($_GET['disable_audio_only_all_posts']) && $_GET['disable_audio_only_all_posts'] == 'true'){
		global $wpdb;
		$posts = $wpdb->get_results("SELECT * FROM $wpdb->posts WHERE `post_type` = 'post'");
		foreach($posts as $post){
			delete_post_meta($post->ID, 'enable_audio_only_comments');
		}
	}
	if(isset($_GET['enable_audio_only_all_pages']) && $_GET['enable_audio_only_all_pages'] == 'true'){
		global $wpdb;
		$posts = $wpdb->get_results("SELECT * FROM $wpdb->posts WHERE `post_type` = 'page'");
		foreach($posts as $post){
			update_post_meta($post->ID, 'enable_audio_comments', 'yes');
			update_post_meta($post->ID, 'enable_audio_only_comments', 'yes');
		}
	}
	if(isset($_GET['disable_audio_only_all_pages']) && $_GET['disable_audio_only_all_pages'] == 'true'){
		global $wpdb;
		$posts = $wpdb->get_results("SELECT * FROM $wpdb->posts WHERE `post_type` = 'page'");
		foreach($posts as $post){
			delete_post_meta($post->ID, 'enable_audio_only_comments');
		}
	}
	
	?>
	<p>
		In addition to controlling voice for individual posts, you may wish to enable voice comments on all current posts. You may accomplish this using the quick actions below.
	</p>
	
	<p style="margin-bottom:0; font-weight: 600; width: 600px">
		This is enabled by default if the voice comments are enabled in the option box above. If you disable  Voice Comments on all posts or pages, all voice comments will be set to Pending.
	</p>
	<a href="<?php echo $_SERVER['SCRIPT_NAME'] ?>?page=evoca_audio_comments&enable_all_posts=true">Enable Voice Comments on all posts</a>
	<br />
	<a href="<?php echo $_SERVER['SCRIPT_NAME'] ?>?page=evoca_audio_comments&disable_all_posts=true">Disable Voice Comments on all posts</a>
	
	<br />
	<br />
	
	<a href="<?php echo $_SERVER['SCRIPT_NAME'] ?>?page=evoca_audio_comments&enable_all_pages=true">Enable Voice Comments on all pages</a>
	<br />
	<a href="<?php echo $_SERVER['SCRIPT_NAME'] ?>?page=evoca_audio_comments&disable_all_pages=true">Disable Voice Comments on all pages</a>
	
	<h3>Voice Only Quick Actions</h3>
	<p>
		Use these actions to enable voice-only comments for all current posts.
	</p>	
	<a href="<?php echo $_SERVER['SCRIPT_NAME'] ?>?page=evoca_audio_comments&enable_audio_only_all_posts=true">Enable Voice-Only Comments on all posts</a>
	<br />
	<a href="<?php echo $_SERVER['SCRIPT_NAME'] ?>?page=evoca_audio_comments&disable_audio_only_all_posts=true">Disable Voice-Only Comments on all posts</a>
	
	<br />
	<br />
	
	<a href="<?php echo $_SERVER['SCRIPT_NAME'] ?>?page=evoca_audio_comments&enable_audio_only_all_pages=true">Enable Voice-Only Comments on all pages</a>
	<br />
	<a href="<?php echo $_SERVER['SCRIPT_NAME'] ?>?page=evoca_audio_comments&disable_audio_only_all_pages=true">Disable Voice-Only Comments on all pages</a>
	
<?php	
}

add_action('admin_menu', 'add_audio_comments_option');
add_action('save_post', 'save_audio_comments_form');

function add_audio_comments_option(){
	if (function_exists('add_meta_box') && get_option('evoca_audio_comments_enabled') == 'yes') {
		add_meta_box('audio_comments', 'Voice Comments', 'audio_comments_option_form', 'page', 'normal', 'low');
		add_meta_box('audio_comments', 'Voice Comments', 'audio_comments_option_form', 'post', 'normal', 'low');
	}
}

function audio_comments_option_form(){
	if(isset($_GET['post']) && get_post_meta($_GET['post'], 'enable_audio_comments', true) == 'yes'){
		echo '<input type="checkbox" checked="checked" name="enable_audio_comments" value="yes"> Enable for This Post';
	}elseif(strpos($_SERVER['REQUEST_URI'], 'post-new.php')){
		echo '<input type="checkbox" checked="checked" name="enable_audio_comments" value="yes"> Enable for This Post';
	}else{
		echo '<input type="checkbox" name="enable_audio_comments" value="yes"> Enable for This Post';
	}
	
	if(isset($_GET['post']) && get_post_meta($_GET['post'], 'enable_audio_only_comments', true) == 'yes'){
		echo '<br /><input type="checkbox" checked="checked" name="enable_audio_only_comments" value="yes"> Enable voice-only comments for This Post';
	}else{
		echo '<br /><input type="checkbox" name="enable_audio_only_comments" value="yes"> Enable Voice-Only Comments for This Post';
	}
}
function save_audio_comments_form($post_ID){
	if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) 
    	return $post_id;
    	
	if(isset($_POST['enable_audio_comments'])){
		update_post_meta($post_ID, 'enable_audio_comments', 'yes');
	}else{
		delete_post_meta($post_ID, 'enable_audio_comments');
	}
	
	if(isset($_POST['enable_audio_only_comments'])){
		update_post_meta($post_ID, 'enable_audio_only_comments', 'yes');
	}else{
		delete_post_meta($post_ID, 'enable_audio_only_comments');
	}
}






add_filter('comment_text', 'fiter_audio_comments', 1);


function fiter_audio_comments(){
	$comment_ID = get_comment_ID();
	global $wpdb;
	$comment_post_ID = $wpdb->get_row("SELECT * FROM $wpdb->comments WHERE `comment_ID` = '$comment_ID'");
	
	//if(get_option('evoca_audio_comments_enabled') == 'yes' && isset($_SERVER['HTTP_REFERER']) && !strpos($_SERVER['HTTP_REFERER'], 'action=edit')):
	
	
if(!strpos($_SERVER['REQUEST_URI'], 'wp-admin')){
	
	$single_player_embed = '<div style="width:290;" id="flashPlayerHTML-Mini-RECORDING_ID">
		<div class="evocaFlashPlayer" id="playerCode-RECORDING_ID">
			<object width="290" height="24" data="http://www.evoca.com/evocaPlayer/wpaudioplayer.swf" classid=clsid:D27CDB6E-AE6D-11cf-96B8-444553540000>
				<param name="movie" value="http://www.evoca.com/evocaPlayer/wpaudioplayer.swf">
				<param name="quality" value="high"/>
				<param name="allowScriptAccess" value="always"/>
				<param name="wmode" value="transparent">
				<param name="flashVars" value="initialvolume=80&amp;titles=RECORDING_TITLE&amp;rid=RECORDING_ID&amp;soundFile=http://www.evoca.com/jsp/mp3.jsp?rid=RECORDING_ID&amp;host=http://www.evoca.com/&amp;listenURL=http://www.evoca.com/lc.jsp?rid=RECORDING_ID&amp;file=http://www.evoca.com/jsp/mp3.jsp?rid=RECORDING_ID" />
				<embed src="http://www.evoca.com/evocaPlayer/wpaudioplayer.swf" width="290" height="24" allowfullscreen="true" allowscriptaccess="always"  wmode="transparent"  flashvars="initialvolume=80&amp;titles=RECORDING_TITLE&amp;rid=RECORDING_ID&amp;soundFile=http://www.evoca.com/jsp/mp3.jsp?rid=RECORDING_ID&amp;host=http://www.evoca.com/&amp;listenURL=http://www.evoca.com/lc.jsp?rid=RECORDING_ID&amp;file=http://www.evoca.com/jsp/mp3.jsp?rid=RECORDING_ID" />
			</object>
		</div>
	</div>';
	
	/*
	<textarea style="display:none" id="codeInfoMini">
	<div style="width:290;" id="flashPlayerHTML-Mini">
		<div id="playerHeader"></div>
		<div class="evocaFlashPlayer" id="playerCode-RECORDING_ID">
			<object width="290" height="24" data="http://www.evoca.com/evocaPlayer/wpaudioplayer.swf" classid=clsid:D27CDB6E-AE6D-11cf-96B8-444553540000>
				<param name="movie" value="http://www.evoca.com/evocaPlayer/wpaudioplayer.swf">
				<param name="quality" value="high"/>
				<param name="allowScriptAccess" value="always"/>
				<param name="wmode" value="transparent">
				<param name="flashVars" value="initialvolume=80&amp;titles=RECORDING_TITLE&amp;rid=RECORDING_ID&amp;soundFile=http://www.evoca.com/jsp/mp3.jsp?rid=RECORDING_ID&amp;host=http://www.evoca.com/&amp;listenURL=http://www.evoca.com/lc.jsp?rid=RECORDING_ID&amp;file=http://www.evoca.com/jsp/mp3.jsp?rid=RECORDING_ID" />
				<embed src="http://www.evoca.com/evocaPlayer/wpaudioplayer.swf" width="290" height="24" allowfullscreen="true" allowscriptaccess="always"  wmode="transparent"  flashvars="initialvolume=80&amp;titles=RECORDING_TITLE&amp;rid=RECORDING_ID&amp;soundFile=http://www.evoca.com/jsp/mp3.jsp?rid=RECORDING_ID&amp;host=http://www.evoca.com/&amp;listenURL=http://www.evoca.com/lc.jsp?rid=RECORDING_ID&amp;file=http://www.evoca.com/jsp/mp3.jsp?rid=RECORDING_ID" />
			</object>
		</div>
		<div id="playerFooter"></div>
	</div>
	</textarea><script src="http://cdn.gigya.com/wildfire/JS/WFButton.js?defaultContent=codeInfoMini&amp;module=post&amp;widgetTitle=Evoca%20Recording&amp;partner=597482&amp;cid=codefield&amp;theme=6&amp;b=click&amp;btnurl=http%3A%2F%2Fwww.evoca.com%2Fimages%2Fshare-button.jpg"></script>';
	*/
	
	
	}else{
	
	
	
		$single_player_embed = '<div style="width:290;" id="flashPlayerHTML-Mini-RECORDING_ID">
		<div class="evocaFlashPlayer" id="playerCode">
			<object width="290" height="24" data="http://www.evoca.com/evocaPlayer/wpaudioplayer.swf" classid=clsid:D27CDB6E-AE6D-11cf-96B8-444553540000>
				<param name="movie" value="http://www.evoca.com/evocaPlayer/wpaudioplayer.swf">
				<param name="quality" value="high"/>
				<param name="allowScriptAccess" value="always"/>
				<param name="wmode" value="transparent">
				<param name="flashVars" value="initialvolume=80&amp;titles=RECORDING_TITLE&amp;rid=RECORDING_ID&amp;soundFile=http://www.evoca.com/jsp/mp3.jsp?rid=RECORDING_ID&amp;host=http://www.evoca.com/&amp;listenURL=http://www.evoca.com/lc.jsp?rid=RECORDING_ID&amp;file=http://www.evoca.com/jsp/mp3.jsp?rid=RECORDING_ID" />
				<embed src="http://www.evoca.com/evocaPlayer/wpaudioplayer.swf" width="290" height="24" allowfullscreen="true" allowscriptaccess="always"  wmode="transparent"  flashvars="initialvolume=80&amp;titles=RECORDING_TITLE&amp;rid=RECORDING_ID&amp;soundFile=http://www.evoca.com/jsp/mp3.jsp?rid=RECORDING_ID&amp;host=http://www.evoca.com/&amp;listenURL=http://www.evoca.com/lc.jsp?rid=RECORDING_ID&amp;file=http://www.evoca.com/jsp/mp3.jsp?rid=RECORDING_ID" />
			</object>
		</div>
	</div>
	<textarea style="display:none" id="codeInfoMini">
	<div style="width:290;" id="flashPlayerHTML-Mini">
		<div id="playerHeader"></div>
		<div class="evocaFlashPlayer" id="playerCode">
			<object width="290" height="24" data="http://www.evoca.com/evocaPlayer/wpaudioplayer.swf" classid=clsid:D27CDB6E-AE6D-11cf-96B8-444553540000>
				<param name="movie" value="http://www.evoca.com/evocaPlayer/wpaudioplayer.swf">
				<param name="quality" value="high"/>
				<param name="allowScriptAccess" value="always"/>
				<param name="wmode" value="transparent">
				<param name="flashVars" value="initialvolume=80&amp;titles=RECORDING_TITLE&amp;rid=RECORDING_ID&amp;soundFile=http://www.evoca.com/jsp/mp3.jsp?rid=RECORDING_ID&amp;host=http://www.evoca.com/&amp;listenURL=http://www.evoca.com/lc.jsp?rid=RECORDING_ID&amp;file=http://www.evoca.com/jsp/mp3.jsp?rid=RECORDING_ID" />
				<embed src="http://www.evoca.com/evocaPlayer/wpaudioplayer.swf" width="290" height="24" allowfullscreen="true" allowscriptaccess="always"  wmode="transparent"  flashvars="initialvolume=80&amp;titles=RECORDING_TITLE&amp;rid=RECORDING_ID&amp;soundFile=http://www.evoca.com/jsp/mp3.jsp?rid=RECORDING_ID&amp;host=http://www.evoca.com/&amp;listenURL=http://www.evoca.com/lc.jsp?rid=RECORDING_ID&amp;file=http://www.evoca.com/jsp/mp3.jsp?rid=RECORDING_ID" />
			</object>
		</div>
		<div id="playerFooter"></div>
	</div>
	</textarea>';
	}

		preg_match('/\[audio_comment id="([0-9]+)"/', get_comment_text(), $id_matches);
		preg_match('/recording_title="([a-zA-Z1-9 ]*)"\]/', get_comment_text(), $title_matches);
		
		
		if(isset($title_matches[1])){
			$recording_title = $title_matches[1];
			$custom_title = true;
		}else{
			$recording_title = "Comment Recording";	
		}

	
		if(isset($id_matches[1])){
			$id = $id_matches[1];
			$player_embed_with_id = str_replace('RECORDING_ID', $id, $single_player_embed);
			$player_embed_with_id = str_replace('RECORDING_TITLE', $recording_title, $player_embed_with_id);
			echo $player_embed_with_id;
			$shortcode_with_id = '[audio_comment id="' . $id . '"]';
			
			if(isset($custom_title)){
				//$comment_text = str_replace(get_comment_text(), '', 'recording_title="' . $recording_title .'"', $replace_length);
				$comment_text = preg_replace('/recording_title="([a-zA-Z1-9 ]*)"\]/', '', get_comment_text());
			}else{
				$comment_text = get_comment_text();
			}
			
			$text = substr_replace($comment_text, '', strpos($comment_text, $shortcode_with_id), strlen($shortcode_with_id));
			
			if(isset($text)) {
				$text = '<p>' . $text . '</p>';
			}
			
			echo $text;
		}
	else {	
	
		$text = get_comment_text();
		
		if(isset($text)) {
			$text = '<p>' . $text . '</p>';
		}
		
		
		echo $text;
	}
	
	//endif;
}


if(get_option('evoca_audio_comments_enabled') == 'yes' && get_option('evoca_user_id') != ''){
	add_filter('comment_form', 'recorder_field');
}
function recorder_field(){
	$enabled = get_post_meta(get_the_ID(), 'enable_audio_comments', true);
	if($enabled == 'yes'): ?>
	
	<script type="text/javascript" src="<?php echo WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)); ?>swfobject.js"></script>
	
	<script type="text/javascript" src="<?php echo WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)); ?>scripts.js"></script>
	
	<script type="text/javascript" src="<?php echo WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)); ?>jquery.1.4.2.min.js"></script>
	
	<script type="text/javascript" id="pluginurl">
		
		var plugin_url = "<?php bloginfo('wpurl') ?>/wp-content/plugins/evoca-audio-recorder";
		
		var owner_id = "<?php echo get_option('evoca_user_id') ?>";
		<?php if(get_post_meta(get_the_ID(), 'enable_audio_only_comments', true) == 'yes'):
				echo 'var audio_only = true';
			else:
				echo 'var audio_only = false';
			endif; ?>
	</script>
	
	<script type="text/javascript" id="writer">
		var isIE = false;
		
		if(navigator.appName.indexOf("Microsoft Internet")!=-1) {
			isIE = true;
		}
		
		log('isIE: ' + isIE);
		
		TA = document.forms['commentform'].url;
		log('TA: ' + TA);
		newP = document.createElement("p");
		newP.className = "comment-form-recorder";
		
		
		var lightBoxText = '<a href="#comments" id="show-recorder-lightbox-help">How to</a>';
		lightBoxText += '<span id="recorder-lightbox-help-content" style="display:none">';
		lightBoxText += '<span class="recorder-help-content-inner">';
		lightBoxText += 'Record your voice, with or without adding text comments. Press the Record button <img src="<?php echo WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)); ?>img/record-button.gif" /> and speak into your microphone.';
		lightBoxText += ' Press the Play button <img src="<?php echo WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)); ?>img/play-button.gif" /> to listen to your comment.';
		lightBoxText += ' Click the Comment button to submit it. Or click the Restart button <img src="<?php echo WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)); ?>img/restart-button.gif" /> to re-record.';
		lightBoxText += '</span>';
		
		
		
		lightBoxText += '<span class="recorder-help-content-inner"><img align="right" src="<?php echo WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)); ?>img/flash-privacy.gif" />First-time user? To set your browser to record permanently on this site, right click or double click (with some Mac mouses) anywhere on the recorder. Select "Settings", "Allow", "Remember", and "Close". This action will not affect your security setting for any other website. You also can select "Allow" just for one comment recording.</span>';
		lightBoxText += '<a class="recorder-help-content-inner" id="hide-recorder-lightbox-help">Close</a></span><span id="lightbox-bg" style="position:fixed; left:0; top:0; width: 100%; height: ' + jQuery(document).height() +  'px; background: #000; z-index: 999; opacity: .8; display: none"></span>';
		log('lightBoxText: ' + lightBoxText);
		
		var embedCode = '<embed type="application/x-shockwave-flash" src="http://www.evoca.com/evocaRecorder/BGRecorder-1.0.swf" width="480" height="140" id="recorderPRD" name="recorderPRD" wmode="transparent" quality="high" allowscriptaccess="always" allowfullscreen="false" movie="http://www.evoca.com/evocaRecorder/SimpleRecorder.swf" flashvars="owner_id=<?php echo get_option('evoca_user_id') ?>" >'; // 
		
		embedCode += '<br />' + lightBoxText;
		log('embedCode: ' + embedCode);
		
		var objectCode = '<object id="recorderPRD" name="recorderPRD" classid=clsid:D27CDB6E-AE6D-11cf-96B8-444553540000 width="480" height="140"><param name="FlashVars" value="owner_id=<?php echo get_option('evoca_user_id') ?>"><param name="movie" value="http://www.evoca.com/evocaRecorder/BGRecorder-1.0.swf"><param name="quality" value="high"><param name="AllowScriptAccess" value="always"><param name="wmode" value="transparent"><param name="allowfullscreen" value="false"></object>';
		
		objectCode =  objectCode + '<br />' + lightBoxText;
		
		log('objectCode' + objectCode);


		var codeToUse = embedCode;
		
		if(isIE) {
			codeToUse = objectCode;
		}

		var newString = '<!-- Here is where the recording ID goes. --> 					<input type="hidden" name="recording_ID" value="" id="recording_ID" /> 		<span id="flashRecorder" name="flashRecorder">' + codeToUse + '</span><input id="new-submit" id="new-submit" type="submit" style="display:none" />';
		log('newString: ' + newString);
		
		if(!isIE) {
			newP.innerHTML = newString;
		}
		
		var loggedIn = false;
		
		<?php if(is_user_logged_in()){
			echo "loggedIn = true;";
			
			global $current_user;
			get_currentuserinfo();
			echo 'userEmail = "' . $current_user->user_email . '";';
		}
		?>

		if(loggedIn){
			log('logged in');
			var hiddenFields = '<input type="hidden" name="email" id="email" value="<?php echo $current_user->user_email?>"><input type="hidden" name="author" id="author" value="<?php echo $current_user->display_name?>">';
			
			if(!isIE) {
				TA = document.forms['commentform'];
				var htmlHolder = TA.innerHTML;
			
				TA.innerHTML = '';
				TA.appendChild(newP);
				TA.innerHTML += '</span>' + hiddenFields + htmlHolder;
			}
			else {
				var formElement = document.forms['commentform'].comment;
				var parent = formElement.parentNode;
				
				parent.innerHTML = newString + '<br /><br />' + hiddenFields + parent.innerHTML;
			}
			
			
		}else{
			if(!isIE) {
				//TA.parentNode.appendChild(newP);
				var formElement = document.forms['commentform'].comment;
				var parent = formElement.parentNode;
				
				parent.innerHTML = newP.innerHTML + '<br /><br />' + parent.innerHTML;
			}
			else {
				var formElement = document.forms['commentform'].comment;
				var parent = formElement.parentNode;
				log('parent: ' + parent);
				log('parent.innerHTML before: ' + parent.innerHTML);
				parent.innerHTML = newString + '<br /><br />' + parent.innerHTML;
				log('parent.innerHTML: ' + parent.innerHTML );
				/*
				var parent = document.forms['commentform'].url;
				var sibling = parent.nextSibling;
				var sparent = parent.parentNode;
				var firstChild = sparent.firstChild;
				
				var codeHTML = "<br /><br />" + newP.innerHTML;
				
				if(sibling != null && sibling.nextSibling != null) {
					var next = sibling.nextSibling;
					
					if(next != null && next.innerHTML != null && next.innerText == 'Website')
						next.outerHTML += codeHTML;
					else
						parent.outerHTML += codeHTML;
				}
				else
					parent.outerHTML += codeHTML;
				*/
			}
		}
		log('window.onload');
		window.onload = function(){
			log('onload in php file');
			
			submit = document.getElementById('submit');
			log('submit button: ' + submit);
			
			if(submit === null){
				log('submit button is null... looking again');
				
				var inputs = document.forms['commentform'].elements;
				for(var i = 0; i < inputs.length; i++){
					if(inputs[i].type == 'submit'){
						submit = inputs[i];
					}
				}
			}
			
			log('submit button: ' + submit);
		
			function initializeForm(){
				var submitClick = true;
				return validateForm();
			}
			
			if(isIE) {
				log('cloning button for IE');
				var submitClone = document.createElement("input");
				submitClone.type = 'button';
				submitClone.name = 'submit-button';
				submitClone.id = 'submit-button';
				submitClone.value = submit.value;
				submitClone.className = submit.className;
				
				submitClone.attachEvent('onclick',initializeForm);
	
				submit.parentNode.replaceChild(submitClone, submit);
			}
			else {
				log('changing type for non-IE browsers');
				submit.type = 'button';
				submit.name = 'submit-button';
				submit.id = 'submit-button';
		
				submit.addEventListener('click',initializeForm,false);
				log('added event listener to the submit button');
			}
			
			
			log('foo');
			if(!jQuery){
			
				var jqueryTag = document.createElement('script');
				jqueryTag.src = '<?php echo get_bloginfo('wpurl') . '/wp-content/plugins/comments/jquery.1.4.2.min.js'; ?>';
				jqueryTag.type = 'text/javascript';
				document.getElementsByTagName("header")[0].appendChild(jqueryTag);	
				
			}
			
			log('setting jQuery');
			jQuery(document).ready(function(){
				log('1');
				var content = document.getElementById('recorder-lightbox-help-content');
				content.style.width = "440px";
				content.style.background = "#fff";
				content.style.fontFamily = "Arial, Helvetica, sans-serif";
				content.style.position = "fixed";
				content.style.left = (jQuery(window).width() - 400) / 2 + jQuery(window).scrollLeft() + "px";
				content.style.top = (jQuery(window).height() - 300) / 2  + "px";
				content.style.zIndex = "1000";
				content.style.fontSize = "14px";
				content.style.lineHeight = "20px";
				
				//var closeButton = document.getElementById('hide-recorder-lightbox-help');
				//closeButton.style=cursor = "pointer";
				
				jQuery('.recorder-help-content-inner').css('margin', '10px');
				jQuery('.recorder-help-content-inner').css('display', 'block');
				 
				//jQuery("recorder-lightbox-help").
					 
				jQuery('#show-recorder-lightbox-help').click(function(){
					jQuery("#lightbox-bg").fadeIn();
					jQuery("#recorder-lightbox-help-content").fadeIn();
				});
				 
				jQuery("#lightbox-bg").click(function(){
					jQuery("#lightbox-bg").fadeOut();
					jQuery("#recorder-lightbox-help-content").fadeOut();
				});
				
				jQuery("#hide-recorder-lightbox-help").click(function(){
					jQuery("#lightbox-bg").fadeOut();
					jQuery("#recorder-lightbox-help-content").fadeOut();
				});
			});
		}
		
		if(typeof(userEmail) !== 'undefined'){
			document.forms['commentform'].email.value = userEmail;
		}
		
		if(audio_only){
			var p = null;
			var p_children = null;
			if(p === null){
				p = document.forms['commentform'].childNodes;
				for (var i = 0; i < p.length; i++){
					if(p[i].tagName == "TEXTAREA"){
						p[i].style.display = "none";
					}
					p_children = p[i].childNodes;
					for(var x = 0; x < p_children.length; x++){
						if(p_children[x].tagName == "TEXTAREA"){
						p_children[x].style.display = "none";
						}
					}
				}
			}else{
				p.style.display = "none";
			}
		}
		
		function validateForm(){
			if(!loggedIn){
				if(document.forms['commentform'].author.value == ''){
					alert('Please check your name');
					return;
				}
				var filter = /^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;
				var address = document.forms['commentform'].email.value;
				if(filter.test(address) == false){
					alert('Please check your email');
					return
				}
				
				recordingSave();
			}
			else {
				recordingSave();
			}
		}	
	</script>
	
<?php
endif;
}



function audio_comments_check_username_and_password(){
	
	$username = get_option('evoca_username');
	$password = get_option('evoca_password');
		
	if($username != '' AND $password != ''){
  	    $user = "https://www.evoca.com/Request?action=userID&userName=$username&key=$password";
  	    
  	    error_reporting(OFF);
  	    $is_user = fopen($user, 'r');
  	
  	    if($is_user){
  	   		//return true;
  	    	update_option('evoca_user_id', file_get_contents($user));
  	    	return file_get_contents($user);
  	    }else{
  	    	update_option('evoca_user_id', '');
  	    }
  	    
  	}else{
  	
  	    return false;
	
  	}
  	
  		
}
?>